Index: code/branches/presentation/src/libraries/network/MasterServer.cc
===================================================================
--- code/branches/presentation/src/libraries/network/MasterServer.cc	(revision 7749)
+++ code/branches/presentation/src/libraries/network/MasterServer.cc	(revision 7750)
@@ -61,5 +61,4 @@
         != mainlist.serverlist.end(); ++i ) 
     {
-      /* WORK MARK */
       /* send this particular server */
       /* build reply string */
@@ -88,9 +87,10 @@
     } 
 
-    /* send end-of-list packet */
+    /* create end-of-list packet */
     reply = enet_packet_create( MSPROTO_SERVERLIST_END,
         MSPROTO_SERVERLIST_END_LEN + 1,
         ENET_PACKET_FLAG_RELIABLE );
 
+    /* send end-of-list packet */
     enet_peer_send( event->peer, 0, reply );
 
@@ -159,5 +159,4 @@
   { /* validate packet */
     if( !event || !(event->packet) || !(event->peer) )
-      //|| !(event->packet->data) || !strlen(event->packet->data) )
     { COUT(2) << "No complete event given.\n";
       return -1;
@@ -168,6 +167,5 @@
     enet_address_get_host_ip( &(event->peer->address), addrconv, 49 );
 
-    /* DEBUG */
-    /* output debug info about the data that has come, to be removed */
+    /* output debug info about the data that has come */
     helper_output_debug( event, addrconv );
 
@@ -275,5 +273,4 @@
 
     /***** INITIALIZE GAME SERVER AND PEER LISTS *****/
-    //this->mainlist = new ServerList();
     this->peers = new PeerList();
 
@@ -292,5 +289,4 @@
     /* clear the list of connected game servers */
     /* clear the list of connected game clients */
-
   }
 
Index: code/branches/presentation/src/libraries/network/MasterServerProtocol.h
===================================================================
--- code/branches/presentation/src/libraries/network/MasterServerProtocol.h	(revision 7749)
+++ code/branches/presentation/src/libraries/network/MasterServerProtocol.h	(revision 7750)
@@ -33,7 +33,9 @@
 #define MS_ADDRESS "129.132.3.8"
 
+/* Client token (shows that the party sending data is a client */
 #define MSPROTO_CLIENT "CL"
 #define MSPROTO_CLIENT_LEN 2 
 
+/* Request: Serverlist (requiest made from client to master server */
 #define MSPROTO_REQ_LIST "REQ:LIST"
 #define MSPROTO_REQ_LIST_LEN 8
@@ -42,12 +44,19 @@
 
 
+/* Game server token (shows that the party sending data is a game server) */
 #define MSPROTO_GAME_SERVER "GS"
 #define MSPROTO_GAME_SERVER_LEN 2
 
+/* Register game server at the master server, meaning request to be taken into$
+ * the master servers game server list.
+ */
 #define MSPROTO_REGISTER_SERVER "REG:SER"
 #define MSPROTO_REGISTER_SERVER_LEN 7
 
+/* Server list item token */
 #define MSPROTO_SERVERLIST_ITEM "SI"
 #define MSPROTO_SERVERLIST_ITEM_LEN 2
+
+/* server list end token */
 #define MSPROTO_SERVERLIST_END "SL_END"
 #define MSPROTO_SERVERLIST_END_LEN 6
@@ -55,15 +64,14 @@
 
 
-
-
-
+/* default master server port */
 #define ORX_MSERVER_PORT 55566
 
 
+/* some constants for the networking of the master server, not very important.
+ * play with those if things don't work out well.$
+ */
 #define ORX_MSERVER_MAXCONNS 32
 #define ORX_MSERVER_MAXCHANS 2
 
 
-
-
 #endif /* MASTER_SERVER_PROTO */
Index: code/branches/presentation/src/libraries/network/Server.cc
===================================================================
--- code/branches/presentation/src/libraries/network/Server.cc	(revision 7749)
+++ code/branches/presentation/src/libraries/network/Server.cc	(revision 7750)
@@ -101,5 +101,5 @@
 
 
-  /* TODO */
+  /** helper that connects to the master server */
   void Server::helper_ConnectToMasterserver()
   {
@@ -173,4 +173,5 @@
   { 
     /* handle incoming data */
+    /* TODO this is to be implemented. */
 
     /* done handling, return all ok code 0 */
@@ -180,4 +181,7 @@
   void Server::helper_HandleMasterServerRequests()
   { 
+    /* poll the master server for replies and see whether something 
+     * has to be done or changed.
+     */
     this->msc.pollForReply( rephandler ); 
   }
Index: code/branches/presentation/src/libraries/network/WANDiscovery.cc
===================================================================
--- code/branches/presentation/src/libraries/network/WANDiscovery.cc	(revision 7749)
+++ code/branches/presentation/src/libraries/network/WANDiscovery.cc	(revision 7750)
@@ -47,8 +47,8 @@
     COUT(4) << "Creating WANDiscovery.\n";
   
-    /* register object with orxonox main class */
+    /* register object in orxonox */
     RegisterObject(WANDiscovery);
 
-    /* ... and register a config value function for it */
+    /* check for the masterserver address option in orxonox.ini */
     this->setConfigValues();
 
@@ -68,4 +68,7 @@
   void WANDiscovery::setConfigValues()
   {
+    /* update msaddress string from orxonox.ini config file, if it 
+     * has changed. 
+     */
     SetConfigValue( msaddress, "localhost");
   } 
Index: code/branches/presentation/src/libraries/network/WANDiscovery.h
===================================================================
--- code/branches/presentation/src/libraries/network/WANDiscovery.h	(revision 7749)
+++ code/branches/presentation/src/libraries/network/WANDiscovery.h	(revision 7750)
@@ -57,5 +57,8 @@
       ~WANDiscovery();
 
-      /** get content of msaddress */
+      /** \return Address of the master server
+       * 
+       * Get the master server address 
+       */
       std::string getMSAddress()
       { return this->msaddress; }